#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>

#define BUFFERSIZE 30000
extern char buffer[BUFFERSIZE+32];
extern int topslot,ascent,descent;
extern int dotranslate;

void do_redraw (int whandle, int x, int y, int w, int h);
void show_cinfo (void);
void show_params (void);
void clip (int slot);

void redraw (int handle, int p[4]);
void move_file (int whandle, int event);
int find_slot (int whandle);
void show_goto (void);
void show_search (void);
void show_replace (void);
void window_find (void);
void search_again (void);
int abort_prog (void);

void wredraw (int slot, int clip[4], Window w);

void refresh_top (void);

int find_cursor (filetyp *ft);

void vslide_file (int whandle, int position);
void hslide_file (int whandle, int position);
void wsize_file (int whandle, int x, int y, int w, int h);
void wmove_file (int whandle, int x, int y, int w, int h);
void wfull_file (int whandle);
void wtop_file (int whandle);

void wsize (int slot);
void wcorrect (int slot, int *x, int *y, int *w, int *h);
void vscroll (int slot, int lines);
void hscroll (int slot, int columns);
void resize (int slot);

int unscramble (char *from, char *end,
	int left, int length, int tabsize, int x, int y, int width);
void redraw_line (char *line, filetyp *ft, int x, int y);
void cursor (int x, int y);
void toggle_cursor (int slot);

int resource (void);

void key_interpret (int key);
void button_interpret (XButtonEvent *event);
int edit_line (int key);

void cycle_window (void);

void show_help(void);

void find_bracket (void);
void check_text (void);
void do_link (void);
void backsave (void);

void menukey (int);

void bline (int pos, char *s);

int main_loop (int argc, char *argv[]);

/****** XWindow headers ***********/

extern Display *display;
extern Window window,twindow,bwindow,vwindow,vuwindow,vdwindow,swindow,
	awindow,a1window,aswindow[4];
extern GC gc,invgc,xorgc;

void process_event (XEvent *event);
int event_key (void);
int translate (XKeyEvent *event);
void clear_screen (void);
extern int wscreen,hscreen, wdesk, hdesk, xdesk, ydesk;
extern unsigned long mask; /* input mask */
extern long memsize; /* size of memory to be used */
extern int gl_hchar,gl_wchar,gl_ende;
extern int twidth,theight,vwidth,vheight,bwidth,bheight;

void draw_arrows (void);
void show_cinsert (void);
